//Copyright (C) 2017 by Han Kleijn, www.hnsky.org
// email: han.k.. at...hnsky.org

//This program is free software: you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation, either version 3 of the License, or
//(at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program.  If not, see <http://www.gnu.org/licenses/>.

program bash;
uses sysutils,
    shellapi, process, windows;
var
   i,location : integer;
   command1, command2,temp,application_Path   : string;
   f : text;



procedure ExecuteAndWait(const aCommando: string;show_console:boolean);
var
  tmpStartupInfo: TStartupInfo;
  tmpProcessInformation: TProcessInformation;
  tmpProgram: String;
  console :longint;
begin
  tmpProgram := trim(aCommando);
  FillChar(tmpStartupInfo, SizeOf(tmpStartupInfo), 0);
  with tmpStartupInfo do
  begin
    cb := SizeOf(TStartupInfo);
    wShowWindow := SW_HIDE;
  end;
  if show_console then console:=CREATE_NEW_CONSOLE else console:=CREATE_NO_WINDOW;

  if CreateProcess(nil, pchar(tmpProgram), nil, nil, true, console ,
    nil, nil, tmpStartupInfo, tmpProcessInformation) then
  begin
    // loop every 20 ms
    while WaitForSingleObject(tmpProcessInformation.hProcess, 20) > 0 do
    begin
     // Application.ProcessMessages;
    end;
    FileClose(tmpProcessInformation.hProcess); { *Converted from CloseHandle* }
    FileClose(tmpProcessInformation.hThread); { *Converted from CloseHandle* }
  end
  else
  begin
    RaiseLastOSError;
  end;
end;

begin
  if paramcount=0 then
  begin
    writeln('Interface between Win10 Bash and Cygwin Bash for Astrometry.net access. This will allow to access the Win10 Bash.');
    writeln('Place this program in a directory such as \astrometry\bin  Enter as location \astrometry.');
    writeln('Written by han.k@hnsky.org, 2018-2-1. Visit www.hnsky.org');
    writeln('Received and send commands are written to log file bash_replacement_log.txt');
    writeln('Hit enter to continue');
    readln;
    exit;
  end;

  command1:='';
  for i:=1 to paramcount do
    command1:=command1+paramstr(i)+' ';

  {clean up for some users}
  command1:=StringReplace(command1,'\','',[rfReplaceAll]);
  command1:=StringReplace(command1,'`','',[rfReplaceAll]);
  command1:=StringReplace(command1,'cygpath -a','',[rfReplaceAll]);
  {end of clean up for some users}

  command2:='';
  for i:=1 to paramcount do
  begin
     temp:=paramstr(i);
     temp:=trim(temp);

     location:=pos('--login',temp);
     if location<>0 then {contains search}
      delete(temp,location,7);

     location:=pos('solve-field',temp);
     if location<>0 then {contains search}
      insert(#34,temp,location); {char 34 = '"' }

     location:=pos(':',temp);
     if location<>0 then {contains search}
     begin
        // C:\Windows\System32\bash.exe -c "solve-field '/mnt/c/astap.fpc/_M95_test_image.fit' --overwrite --downsample 4"
        temp:=copy(temp,1,location-2)+#39+'/mnt/'+lowercase(copy(temp,location-1,1))+copy(temp,location+1,length(temp)-location)+#39;{Drive letter should be lowercase. Add #39 for filenames with spaces}
     end;
     command2:=command2+' '+temp;
  end;
  command2:=command2+'"';
  {write log file}
  try
    application_Path:=ExtractFilePath(ParamStr(0));
    assign(f,application_Path+'\bash_replacement_log.txt');
    rewrite(f);
    writeln(f,'input: '+  command1);
    writeln(f,'output: C:\Windows\System32\bash.exe '+command2);
    close(f);
  except
  end;

  {execute bash}
  writeln('Win10 Bash interface. www.hnsky.org.');
  Executeandwait('C:\Windows\System32\bash.exe '+command2,true);
end.

